﻿@page "/prefecture-list"
@inject HttpClient HttpClient
@inject IDialogService DialogService;
@inject ISnackbar Snackbar

<PageTitle Title="都道府県" Description="都道府県マスタのメンテナンスをします。" />

<MudTable Items="@_prefectures" FixedHeader="true" LoadingProgressColor="Color.Primary"
          Loading="@_isLoading" Dense="@dense" Hover="@hover" Bordered="@bordered" Striped="@striped"
          Filter="new Func<PrefectureEntity, bool>(FilterFunc1)" @bind-SelectedItem="selectedItem1">
    <ToolBarContent>
        <MudTextField @bind-Value="_searchString" Placeholder="都道府県名を入力しエンターを押下してください。" />
        <MudSpacer />
        <MudTooltip Text="新規追加">
            <MudFab Color="Color.Primary" Icon="@Icons.Material.Filled.Add" Size="Size.Medium" IconSize="Size.Small" Class="ma-2" @onclick="(e => Create())" />
        </MudTooltip>
    </ToolBarContent>
    <HeaderContent>
        <MudTh>都道府県ID</MudTh>
        <MudTh>地方名</MudTh>
        <MudTh>都道府県名</MudTh>
        <MudTh>操作</MudTh>
    </HeaderContent>
    <RowTemplate>
        <MudTd DataLabel="PrefectureId">@context.PrefectureId</MudTd>
        <MudTd DataLabel="RegionName">@context.Region.RegionName</MudTd>
        <MudTd DataLabel="PrefectureName">@context.PrefectureName</MudTd>
        <MudTd>
            <MudTooltip Text="照会">
                <MudFab Color="Color.Primary" OnClick="@(e => Show(@context.PrefectureId))" Icon="@Icons.Material.Filled.ListAlt" Size="Size.Small"></MudFab>
            </MudTooltip>
            <MudTooltip Text="編集">
                <MudFab Color="Color.Primary" OnClick="@(e => Update(@context.PrefectureId))" Icon="@Icons.Material.Filled.Edit" Size="Size.Small"></MudFab>
            </MudTooltip>
            <MudTooltip Text="削除">
                <MudFab Color="Color.Primary" OnClick="@(e => Delete(@context.PrefectureId))" Icon="@Icons.Material.Filled.Delete" Size="Size.Small"></MudFab>
            </MudTooltip>
        </MudTd>
    </RowTemplate>
    <PagerContent>
        <MudTablePager RowsPerPageString="1ページ当たりの行数" />
    </PagerContent>
</MudTable>

<MudSwitch @bind-Checked="@hover" Color="Color.Primary">Hover</MudSwitch>
<MudSwitch @bind-Checked="@dense" Color="Color.Secondary">Dense</MudSwitch>
<MudSwitch @bind-Checked="@striped" Color="Color.Tertiary">Striped</MudSwitch>
<MudSwitch @bind-Checked="@bordered" Color="Color.Warning">Bordered</MudSwitch>

@code {
    private bool _isLoading { get; set; } = false;
    private bool dense = false;
    private bool hover = true;
    private bool striped = false;
    private bool bordered = false;
    private string _searchString;
    private IEnumerable<PrefectureEntity> _prefectures { get; set; } = new List<PrefectureEntity>();
    private PrefectureEntity selectedItem1 = null;

    protected override async Task OnInitializedAsync()
    {
        _isLoading = true;
        try
        {
            _prefectures = await HttpClient.GetFromJsonAsync<List<PrefectureEntity>>("api/Prefectures");
        }
        catch (Exception ex)
        {
            Snackbar.Add(ex.Message, Severity.Error);
        }
        _isLoading = false;
    }

    private bool FilterFunc1(PrefectureEntity element) => FilterFunc(element, _searchString);

    private bool FilterFunc(PrefectureEntity element, string searchString)
    {
        if (string.IsNullOrWhiteSpace(searchString))
            return true;
        if (element.PrefectureName.Contains(searchString, StringComparison.OrdinalIgnoreCase))
            return true;
        if (element.Region.RegionName.Contains(searchString, StringComparison.OrdinalIgnoreCase))
            return true;
        return false;
    }
    private async Task Create()
    {
        var parameters = new DialogParameters();
        parameters.Add("Prefecture", new PrefectureEntity());

        var dialog = await DialogService.Show<PrefectureDetail>("都道府県新規作成", parameters).Result;
        if (dialog.Data != null)
        {
            PrefectureEntity newPrefecture = dialog.Data as PrefectureEntity;
            await HttpClient.PostAsJsonAsync<PrefectureEntity>("api/Prefectures", newPrefecture);
            await OnInitializedAsync();
            Snackbar.Add($"{newPrefecture.PrefectureName}を追加しました。", Severity.Success);
        }

    }
    private async Task Show(int PrefectureId)
    {
        PrefectureEntity Prefecture = await HttpClient.GetFromJsonAsync<PrefectureEntity>($"api/Prefectures/{PrefectureId}");

        var parameters = new DialogParameters();
        parameters.Add("Prefecture", Prefecture);
        parameters.Add("IsReadOnly", true);
        var dialog = await DialogService.Show<PrefectureDetail>("都道府県編集", parameters).Result;
    }

    private async Task Update(int PrefectureId)
    {
        PrefectureEntity Prefecture = await HttpClient.GetFromJsonAsync<PrefectureEntity>($"api/Prefectures/{PrefectureId}");

        var parameters = new DialogParameters();
        parameters.Add("Prefecture", Prefecture);
        var dialog = await DialogService.Show<PrefectureDetail>("都道府県編集", parameters).Result;

        if (dialog.Data != null)
        {
            PrefectureEntity updatePrefecture = dialog.Data as PrefectureEntity;
            updatePrefecture.UpdatedOn = DateTime.Now;
            await HttpClient.PutAsJsonAsync<PrefectureEntity>($"api/Prefectures/{PrefectureId}", updatePrefecture);
            await OnInitializedAsync();
            Snackbar.Add($"{updatePrefecture.PrefectureName}を保存しました。", Severity.Success);
        }
    }

    private async Task Delete(int PrefectureId)
    {
        PrefectureEntity deletedPrefecture = await HttpClient.GetFromJsonAsync<PrefectureEntity>($"api/Prefectures/{PrefectureId}");
        bool? result = await DialogService.ShowMessageBox("警告",
                                                       $"{deletedPrefecture.PrefectureName}を削除してもよろしいですか？",
                                                       yesText: "削除",
                                                       cancelText: "キャンセル");
        if (result != null && result == true)
        {
            await HttpClient.DeleteAsync($"api/Prefectures/{PrefectureId}");
            await OnInitializedAsync();
            Snackbar.Add($"{deletedPrefecture.PrefectureName}を削除しました。", Severity.Success);
        }
    }
}